/*
 * d_FIR.c
 *
 *  Created on: 2018328
 *      Author: Administrator
 */

#include "d_FIR.h"
#include <services\int\adi_int.h>
#include <stdlib.h>

extern float fir_input_left[];
extern float fir_input_right[];
extern float fir_output_left[];
extern float fir_output_right[];
extern float fir_coeffs[];
extern volatile int acc_over;

extern void FIR_ACC_ISR();
// TCB Initialization
int FIR_TCB_RIGHT[13]={
                0,
                FIR_TAPS,
                -1,
                (int)fir_coeffs+FIR_TAPS-1,
                (int)fir_output_right,
                FIR_AUDIO_BLOCK_SIZE,
                1,
                (int)fir_output_right,
                (int)fir_input_right,
                FIR_TAPS + FIR_AUDIO_BLOCK_SIZE - 1,
                1,
                (int)fir_input_right,
                (FIR_TAPS-1)|((FIR_AUDIO_BLOCK_SIZE-1)<<14)
            };

int FIR_TCB_LEFT[13]={
                (int)FIR_TCB_RIGHT+12,
                FIR_TAPS,
                -1,
                (int)fir_coeffs+FIR_TAPS-1,
                (int)fir_output_left,
                FIR_AUDIO_BLOCK_SIZE,
                1,
                (int)fir_output_left,
                (int)fir_input_left,
                FIR_TAPS + FIR_AUDIO_BLOCK_SIZE - 1,
                1,
                (int)fir_input_left ,
                (FIR_TAPS-1)|((FIR_AUDIO_BLOCK_SIZE-1)<<14)
            };

/* Adding the Initialization Code for FIR Accelerator Now */
void init_FIR(void)
{
    int temp;

    FIR_TCB_RIGHT[0] = (int) FIR_TCB_LEFT + 12;

    //Mapping the FIR DMA interrupt
    temp = *pPICR0;
    temp &= ~(P0I0 | P0I1 | P0I2 | P0I3 | P0I4);
    temp |= P0I0 | P0I1 | P0I3 | P0I4;
    *pPICR0 = temp;
    //interrupt(SIG_P0,ACC_ISR);
    adi_int_InstallHandler(ADI_CID_P0I, (ADI_INT_HANDLER_PTR)FIR_ACC_ISR, NULL, true);

    //Selecting the FIR Accelerator
    temp = *pPMCTL1; // --> in previous versions PMCTL_EXT, perhaps have to be changed, if you don't have "def21469.h" and "Cdef21469.h" in the versions according to 2146x Hardware Reference 0.2
    temp &= ~(BIT_17 | BIT_18);
    temp |= FIRACCSEL;
    *pPMCTL1 = temp;

    asm("nop;nop;nop;nop;");

    //Initializing the chain pointer register
    *pCPFIR = (int) FIR_TCB_LEFT + 12 - 0x80000;

    //Now Enabling the FIR Accelerator
    //FIR_CCINTR???
    *pFIRCTL1 = FIR_EN | FIR_DMAEN | FIR_CH2 | FIR_CCINTR;

}


void FIR_ACC_ISR()
{
    acc_over=1;
}
