/*
 * d_I2S.c
 *
 *  Created on: 2018322
 *      Author: Administrator
 */

#include "d_I2S.h"

#include <services\int\adi_int.h>
#include <sru.h>
#include <sys/platform.h>
#include <stdlib.h>

#define AUDIO_IN_OUT_CNT    6//2ֵó2
#define RX_TX_BUFF_LEN (PLAY_CHANNELS*MAX_AUDIO_BUFF*AUDIO_IN_OUT_CNT)//441*2  //ɼƵΪ44.1KHz,10msɼ441*2

volatile int32_t I2SAudioOUTBuff[RX_TX_BUFF_LEN]; /* SPORT0 transmit buffer A (DMA) */
volatile int32_t I2SAudioINBuff[RX_TX_BUFF_LEN]; /* SPORT1 receive buffer A (DMA) */

int32_t audiobufftemp[PLAY_CHANNELS*MAX_AUDIO_BUFF*6];//2¼ʱ
int32_t audiobuffOTC[PLAY_CHANNELS*MAX_AUDIO_BUFF];//ԭBUff

int xmit0a_tcb[8] = { 0, 0, 0, 0, 0, RX_TX_BUFF_LEN, 1, (int) I2SAudioOUTBuff }; /* SPORT0 transmit a tcb */
int rcv1a_tcb[8] = { 0, 0, 0, 0, 0, RX_TX_BUFF_LEN, 1, (int) I2SAudioINBuff }; /* SPORT1 receive a tcb */

//44.1KHzҲ
int32_t sinTab44[44] = {
0,148892,294766,434667,565760,685387,791125,880831,
952687,1005236,1037414,1048569,1038475,1007336,955783,884861,
796008,691023,572035,441454,301927,156282,7470,-141494,
-287590,-427859,-559456,-679717,-786203,-876756,-949542,-1003085,
-1036301,-1048516,-1039483,-1009385,-958831,-888847,-800850,-696624,
-578281,-448218,-309073,-163665};


void init_I2S(void)
{
    //֡ͬ
    SRU(DAI_PB06_O, SPORT0_FS_I);    // DAIP6 (ALRCLK) to SPORT0 FS (TFS0)
    SRU(DAI_PB06_O, SPORT1_FS_I);    // DAIP6 (ALRCLK) to SPORT1 FS (TFS0)
    //
    SRU(HIGH, PBEN07_I);
    SRU(SPORT0_DA_O, DAI_PB07_I);    // DAIP12 (DSDATA1) to SPORT0 DA (TX)
    //
    SRU(DAI_PB08_O, SPORT1_DA_I);// DAIP8 (ASDATA1) to SPORT1 DA (RX1A)
    //ʱ
    SRU(DAI_PB09_O, SPORT0_CLK_I);// DAIP7 (ABCLK) to SPORT0 CLK (TCLK)
    SRU(DAI_PB09_O, SPORT1_CLK_I);   // DAIP7 (ABCLK) to SPORT1 CLK (TCLK)

    /* Clear out SPORT 0/1 registers */
    *pSPCTL0 = *pSPCTL1 = 0;
    *pSPMCTL0 = *pSPMCTL1 = 0;
    *pSPCTLN0 = *pSPCTLN1 = 0;

    /* External clock and frame syncs generated by AD1939 */
    //ⲿʱ
    *pDIV0 = 0x00000000;  // Transmitter (SPORT0)
    *pDIV1 = 0x00000000; // Receiver (SPORT1) at 12.288 MHz SCLK and 48 kHz sample rate

    /* SPORT0 and SPORT1 are being operated in "I2S" mode.
     This is synonymous with stereo operating mode for the AD1939 */
    rcv1a_tcb[4] = *pCPSP1A = (((int) rcv1a_tcb + 7) & 0x7FFFF) | (1 << 19);

    xmit0a_tcb[4] = *pCPSP0A = (((int) xmit0a_tcb + 7) & 0x7FFFF) | (1 << 19);

    //I2Sģʽ | 32 |  ʹAͨ | DMAͨA | ʹDMAͨA
    *pSPCTL1 = (OPMODE | SLEN32 | SPEN_A | SCHEN_A | SDEN_A);

    //SPTRAN ݻΪģʽ
    *pSPCTL0 = (SPTRAN | OPMODE | SLEN32 | SPEN_A | SCHEN_A | SDEN_A);

    // Unmask SPORT1 RX ISR Interrupt
    adi_int_InstallHandler(ADI_CID_P3I, (ADI_INT_HANDLER_PTR) process_CS4272_samples_ISR, NULL, true);
}

void process_CS4272_samples_ISR(int sig_int, void *pCBParam)
{
    static uint8_t counter = 0;
    int left = 0, right = 0;

    //DMAݽ
    for(int i = 0 ; i < RX_TX_BUFF_LEN ; i++)
    {
        if(I2SAudioINBuff[i] && 0x80000000)
            audiobuffOTC[i] = audiobufftemp[i] = (I2SAudioINBuff[i] >> 8) | 0xFF000000;
        else
            audiobuffOTC[i] = audiobufftemp[i] = (I2SAudioINBuff[i] >> 8);
    }

    //㷨


    //DMAݷ
    for(int i = 0 ; i < RX_TX_BUFF_LEN ; i++)
    {
        I2SAudioOUTBuff[i] = audiobufftemp[i] << 8;
    }
}














