/*
 * d_analog_I2C.c
 *
 *  Created on: 2018322
 *      Author: Administrator
 */

#include "d_analog_I2C.h"

//  I2C_SCL_PIN----DPI_PB6
//  I2C_SDA_PIN----DPI_PB7
    #define I2C_SCL_1()  SRU(LOW, DPI_PBEN06_I)       /* SCL = 1 */
    #define I2C_SCL_0()  SRU(HIGH, DPI_PBEN06_I)      /* SCL = 0 */

    #define I2C_SDA_1()  SRU(LOW, DPI_PBEN07_I)       /* SDA = 1 */
    #define I2C_SDA_0()  SRU(HIGH, DPI_PBEN07_I)      /* SDA = 0 */

    #define I2C_SDA_READ()  ((*pDPI_PIN_STAT)& DPI_PB07)  /* SDA״̬ */



/**********************************************************************************************************
*     : i2c_Delay
*   ˵: I2Cλӳ٣400KHz
*       Σ
*     ֵ: 
**********************************************************************************************************/
//#pragma -O1
inline static void i2c_Delay(void)
{
    uint16_t i;
    /*
         ãI2CʱӴ43KHz
    */
    for (i = 0; i < 1000; i++)//24us
    {
        asm("nop;");
        asm("nop;");//
        asm("nop;");//
        asm("nop;");//
        asm("nop;");//
        asm("nop;");//
        asm("nop;");//
        asm("nop;");//
        asm("nop;");//
        asm("nop;");//
        asm("nop;");//
        asm("nop;");//

    }
}

/**********************************************************************************************************
*     : дĴ
*   ˵: дwm8978Ĵ
*       Σ_ucRegAddr  Ĵַ
*             _usValue Ĵֵ
*     ֵ: 
**********************************************************************************************************/
uint8_t CS4272_WriteReg(uint8_t _ucRegAddr, uint8_t _usValue)
{
    uint8_t ucAck;

    /* ʼλ */
    i2c_Start();

    /* 豸ַ+дbit0 = w 1 = r) bit7 ȴ */
    i2c_SendByte(CS4272_ADDR | I2C_WR);

    /* ACK */
    ucAck = i2c_WaitAck();
    if (ucAck == 1)
        return 0;

    /* Ϳֽ1 */
    i2c_SendByte(_ucRegAddr);

    /* ACK */
    ucAck = i2c_WaitAck();
    if (ucAck == 1)
        return 0;

    /* Ϳֽ2 */
    i2c_SendByte(_usValue);

    /* ACK */
    ucAck = i2c_WaitAck();
    if (ucAck == 1)
        return 0;

    /* STOP */
    i2c_Stop();

    return 1;
}

uint8_t CS4272_ReadReg(uint8_t ReadAddr)
{
    uint8_t temp=0;
    uint8_t ucAck;

    /* ʼλ */
    i2c_Start();

    /* 豸ַ+дbit0 = w 1 = r) bit7 ȴ */
    i2c_SendByte(CS4272_ADDR | I2C_WR);

    /* ACK */
    ucAck = i2c_WaitAck();
    if (ucAck == 1)
        return 0;

    /* ͼĴַ*/
    i2c_SendByte(ReadAddr);

    /* ACK */
    ucAck = i2c_WaitAck();
    if (ucAck == 1)
        return 0;

    /* ʼλ */
    i2c_Start();

    /* 豸ַ+дbit0 = w 1 = r) bit7 ȴ */
    i2c_SendByte(CS4272_ADDR | I2C_RD);

    /* ACK */
    ucAck = i2c_WaitAck();
    if (ucAck == 1)
        return 0;

    temp = i2c_ReadByte();

    /* STOP */
    i2c_Stop();

    return temp;
}

/**********************************************************************************************************
*     : i2c_Start
*   ˵: CPUI2Cź
*       Σ
*     ֵ: 
**********************************************************************************************************/
void i2c_Start(void)
{
    /* SCLߵƽʱSDAһرʾI2Cź */
    I2C_SDA_1();
    I2C_SCL_1();
    i2c_Delay();
    I2C_SDA_0();
    i2c_Delay();
    i2c_Delay();
    I2C_SCL_0();
    i2c_Delay();
}

/**********************************************************************************************************
*     : i2c_Start
*   ˵: CPUI2Cֹͣź
*       Σ
*     ֵ: 
**********************************************************************************************************/
void i2c_Stop(void)
{
    /* SCLߵƽʱSDAһرʾI2Cֹͣź */
    I2C_SDA_0();
    I2C_SCL_1();
    i2c_Delay();
    I2C_SDA_1();
}

/**********************************************************************************************************
*     : i2c_SendByte
*   ˵: CPUI2C豸8bit
*       Σ_ucByte  ȴ͵ֽ
*     ֵ: 
**********************************************************************************************************/
void i2c_SendByte(uint8_t _ucByte)
{
    uint8_t i;

    /* ȷֽڵĸλbit7 */
    for (i = 0; i < 8; i++)
    {
        if (_ucByte & 0x80)
        {
            I2C_SDA_1();
        }
        else
        {
            I2C_SDA_0();
        }
        i2c_Delay();
        I2C_SCL_1();
        i2c_Delay();
        i2c_Delay();
        I2C_SCL_0();
        if (i == 7)
        {
             I2C_SDA_1(); /* ͷ */
        }
        _ucByte <<= 1;  /* һbit */
        i2c_Delay();
    }
}

/**********************************************************************************************************
*     : i2c_ReadByte
*   ˵: CPUI2C豸ȡ8bit
*       Σ
*     ֵ: 
**********************************************************************************************************/
uint8_t i2c_ReadByte(void)
{
    uint8_t i;
    uint8_t value;

    /* 1bitΪݵbit7 */
    value = 0;
    for (i = 0; i < 8; i++)
    {
        value <<= 1;
        I2C_SCL_1();

        //SDAΪģʽ
        SRU (LOW, PBEN07_I);
        SRU (LOW, DAI_PB07_I);

        i2c_Delay();
        if (I2C_SDA_READ())
        {
            value++;
        }

        //SDAΪģʽ
        SRU(FLAG7_O, DPI_PB07_I);

        I2C_SCL_0();
        i2c_Delay();
    }
    return value;
}

/**********************************************************************************************************
*     : i2c_WaitAck
*   ˵: CPUһʱӣȡACKӦź
*       Σ
*     ֵ: 0ʾȷӦ1ʾӦ
**********************************************************************************************************/
uint8_t i2c_WaitAck(void)
{
    uint8_t re;

    I2C_SDA_1();    /* CPUͷSDA */

    //SDAΪģʽ
    SRU (LOW, PBEN07_I);
    SRU (LOW, DAI_PB07_I);

    i2c_Delay();
    I2C_SCL_1();    /* CPUSCL = 1, ʱ᷵ACKӦ */
    i2c_Delay();
    i2c_Delay();
    if (I2C_SDA_READ()) /* CPUȡSDA״̬ */
    {
        re = 1;
    }
    else
    {
        re = 0;
    }
    I2C_SCL_0();
    i2c_Delay();

    //SDAΪģʽ
    SRU(FLAG7_O, DPI_PB07_I);

//  I2C_SDA_1();    /* CPUͷSDA */
    return re;
}

/**********************************************************************************************************
*     : i2c_Ack
*   ˵: CPUһACKź
*       Σ
*     ֵ: 
**********************************************************************************************************/
void i2c_Ack(void)
{
    I2C_SDA_0();    /* CPUSDA = 0 */
    i2c_Delay();
    I2C_SCL_1();    /* CPU1ʱ */
    i2c_Delay();
    I2C_SCL_0();
    i2c_Delay();
    I2C_SDA_1();    /* CPUͷSDA */
}

/**********************************************************************************************************
*     : i2c_NAck
*   ˵: CPU1NACKź
*       Σ
*     ֵ: 
**********************************************************************************************************/
void i2c_NAck(void)
{
    I2C_SDA_1();    /* CPUSDA = 1 */
    i2c_Delay();
    I2C_SCL_1();    /* CPU1ʱ */
    i2c_Delay();
    I2C_SCL_0();
    i2c_Delay();
}

/**********************************************************************************************************
*     : i2c_CfgGpio
*   ˵: I2CߵGPIOģIOķʽʵ
*       Σ
*     ֵ: 
**********************************************************************************************************/
void init_analog_I2C(void)
{
    //SDA SCLΪģʽ
    SRU(FLAG6_O, DPI_PB06_I);
    SRU(FLAG7_O, DPI_PB07_I);

    /* һֹͣź, λI2Cϵ豸ģʽ */
    i2c_Stop();
}

/**********************************************************************************************************
*     : i2c_CheckDevice
*   ˵: I2C豸CPU豸ַȻȡ豸Ӧжϸ豸Ƿ
*       Σ_Address豸I2Cߵַ
*     ֵ: ֵ 0 ʾȷ 1ʾδ̽⵽
**********************************************************************************************************/
uint8_t i2c_CheckDevice(uint8_t _Address)
{
    uint8_t ucAck;

    init_analog_I2C();      /* GPIO */
    i2c_Delay();

    i2c_Start();        /* ź */

    /* 豸ַ+дbit0 = w 1 = r) bit7 ȴ */
    i2c_SendByte(_Address | I2C_RD);//I2C_WR
    ucAck = i2c_WaitAck();  /* 豸ACKӦ */

    i2c_Stop();         /* ֹͣź */

    return ucAck;
}
